/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefFunction The functionality necessary to accomplish the task for which a Device is designed. A device can be designed to perform more than one function. Functions can be structured in categories (subclasses) that reflect different points of view, for example, considering the specific application area for which a function can be used (e.g., light, temperature, motion, heat, power, etc.), or the capability that a function can support (e.g., receive, reply, notify, etc.), and so forth. 
type SarefFunction interface {
	owl.Thing
	sarefHasCommandMultipleSarefCommand
	IsSarefFunction() bool // indicates base class
}

// sSarefFunction The functionality necessary to accomplish the task for which a Device is designed. A device can be designed to perform more than one function. Functions can be structured in categories (subclasses) that reflect different points of view, for example, considering the specific application area for which a function can be used (e.g., light, temperature, motion, heat, power, etc.), or the capability that a function can support (e.g., receive, reply, notify, etc.), and so forth. 
type sSarefFunction struct {
	propCommon
	propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCommand
}

// NewSarefFunction creates a new SarefFunction
func (mod *Model) NewSarefFunction(iri string) (ret SarefFunction, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefFunction{}
	pc := propCommon{iri: iri, typ: "SarefFunction", model: mod}
	res.propCommon = pc
	mod.addSarefFunction(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefFunction) makeMaps() {
	res.sarefHasCommand = make(map[string]SarefCommand)
	return
}

// addSarefFunction adds SarefFunction to model
func (mod *Model) addSarefFunction(res SarefFunction) {
	mod.mSarefFunction[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefFunction returns all resources with given prefix
func (mod *Model) SarefFunction(prefix string) (res []SarefFunction) {
	for i := range mod.mSarefFunction {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefFunction[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefFunction) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#hasCommand":
		if v, ok := obj.(SarefCommand); ok {
			res.DelSarefHasCommand(v)
		}
	default:
	}
	return
}

// isSarefFunction indicates base class
func (res *sSarefFunction) IsSarefFunction() bool {
	return true
}

// SetSarefHasCommand is setter of A relationship between an entity (such as a function) and a command
func (res *sSarefFunction) SetSarefHasCommand(in []SarefCommand) (err error) {
	temp := res.sarefHasCommand
	res.sarefHasCommand = make(map[string]SarefCommand)
	for i := range temp {
		temp[i].DelSarefIsCommandOf(res)
	}
	err = res.AddSarefHasCommand(in...)
	return
}

// AddSarefHasCommand adds A relationship between an entity (such as a function) and a command
func (res *sSarefFunction) AddSarefHasCommand(in ...SarefCommand) (err error) {
	for i := range in {
		if _, ok := res.sarefHasCommand[in[i].IRI()]; !ok {
			res.sarefHasCommand[in[i].IRI()] = in[i]
			in[i].AddSarefIsCommandOf(res)
		}
	}
	return
}

// DelSarefHasCommand deletes A relationship between an entity (such as a function) and a command
func (res *sSarefFunction) DelSarefHasCommand(in ...SarefCommand) (err error) {
	for i := range in {
		if _, ok := res.sarefHasCommand[in[i].IRI()]; ok {
			delete(res.sarefHasCommand, in[i].IRI())
			in[i].DelSarefIsCommandOf(res)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefFunction) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefFunction) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#hasCommand":
		if obj, ok := res.model.mSarefCommand[pred.Object.Term.String()]; ok {
			res.AddSarefHasCommand(obj)
		}
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefFunction) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Function", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefFunction) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCommand.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefFunction) String() (ret string) {
	ret = res.iri + " " + "SarefFunction\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefFunction) propsString() (ret string) {
	ret = ""
	ret += res.propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCommand.String()
	return
}


